import {
  __spreadProps,
  __spreadValues
} from "../chunk-LMOQIXV4.js";
async function createSseFetcher(opts) {
  const { createClient } = await import("graphql-sse"), sseClient = createClient(__spreadValues({
    retryAttempts: 0,
    // @ts-expect-error
    singleConnection: !0,
    // or use false if you have an HTTP/2 server
    // @ts-expect-error
    lazy: !1
  }, opts));
  function subscribe(payload) {
    var _a;
    let deferred;
    const pending = [];
    let throwMe, done = !1;
    const dispose = sseClient.subscribe(
      __spreadProps(__spreadValues({}, payload), {
        // types are different with FetcherParams
        operationName: (_a = payload.operationName) != null ? _a : void 0
      }),
      {
        next(data) {
          pending.push(data), deferred == null || deferred.resolve(!1);
        },
        error(err) {
          throwMe = err, deferred == null || deferred.reject(throwMe);
        },
        complete() {
          done = !0, deferred == null || deferred.resolve(!0);
        }
      }
    );
    return {
      [Symbol.asyncIterator]() {
        return this;
      },
      async next() {
        if (done)
          return { done: !0, value: void 0 };
        if (throwMe)
          throw throwMe;
        return pending.length ? { value: pending.shift() } : await new Promise((resolve, reject) => {
          deferred = { resolve, reject };
        }) ? { done: !0, value: void 0 } : { value: pending.shift() };
      },
      async return() {
        return dispose(), { done: !0, value: void 0 };
      }
    };
  }
  return subscribe;
}
export {
  createSseFetcher
};
